<template>
    <div>
    <div class="card d-block padded no-full-screen">
        <p><span class="card-title">{{ prod.name }}</span></p>
        <p><span class="text-info">Base price:</span> {{ prod.price }}</p>
        <p><span class="text-info">VAT quota:</span> {{ prod.price_diff }}</p>
        <p><span class="text-info">Total price:</span> {{ prod.price_tax }}</p>
    </div>
    <div class="card no-full-screen">
        <label for="paymentType">Payment Type</label>
        <select id="paymentType" v-model="paymentType" class="form-select">
            <option value="simple">Simple</option>
            <option value="partial">Partial</option>
        </select>
        <div  v-if="paymentType === 'partial'">
        <label for="monthlyAmount">Monthly Amount</label>
        <input id="monthlyAmount" v-model="monthlyAmount" class="input-group-text">
        </div>
        <button @click="preview()" class="clickable">Preview payment</button>
        <span v-if="errorMessage.length > 0">{{ errorMessage }}</span>
    </div>
    <div class="card no-full-screen padded" v-if="previewReady">
        <p><span class="card-title">Total: </span>{{ previewData.total }}</p>
        <div v-if="previewData.monthly">
        <p><span class="card-title">Monthly fees:</span></p>
        <div v-for="(fee, month) in previewData.monthly">
            <span class="text-info">{{ month }}:</span>{{ fee }}
        </div>
        </div>
        <button @click="create_order()" class="clickable">Create Order</button>
        <span v-if="message.length > 0">{{ message }}</span>
    </div>
    </div>
</template>

<script>
    import axios from 'axios'
    export default {
        name: "ProductView",
        props: {
            prod: {
                type: Object,
                required: true
            }
        },
        data() {
            return {
                paymentType: 'simple',
                monthlyAmount: null,
                previewReady: false,
                previewData: {},
                errorMessage: '',
                message: ''
            }
        },
        methods: {
            async preview() {
                this.errorMessage = '';
                await axios.post('/api/orders/preview', {
                    payment_type: this.paymentType,
                    products: [this.prod.id],
                    monthly: this.monthlyAmount
                }).then(response => {
                    this.previewData = response.data;
                    this.previewReady = true;
                }).catch(error => {
                    this.errorMessage = error.response.data.error;
                })
            },
            async create_order() {
                await axios.post('/api/orders/create', {
                    payment_type: this.paymentType,
                    products: [this.prod.id],
                    monthly: this.monthlyAmount
                }).then(response => {
                    this.message = "Success!";
                    this.requestSent = true;
                }).catch(response => {
                    this.message = "Something went wrong...";
                    this.requestSent = true;
                })
            }
        }
    }
</script>

<style scoped>
.padded {
    padding-left: 25px;
    padding-top: 25px;
}
.clickable {
    cursor: pointer;
}
.no-full-screen {
    max-width: 500px;
}
</style>